/* GCC */
#include <algorithm>
#include <assert.h>
#include <string.h>
#include <memory.h>
#include <assert.h>
#include <iostream>
#include <iomanip>
#include <cstring>
#include <fstream>
#include <istream>
#include <ostream>
#include <cassert>
#include <complex>
#include <cstdlib>
#include <climits>
#include <math.h>
#include <bitset>
#include <vector>
#include <string>
#include <cstdio>
#include <memory>
#include <time.h>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef complex <double> cd;

const bool db = false;

#define fs first
#define sd second
#define mp make_pair
#define pb push_back
#define ppb pop_back

#define inf 1000000007
#define nmax 1100
#define mmax 50100
#define eps 1e-12

struct Tnode{
    int num[mmax];
};

void multiply(Tnode &a,const int &b)
{
    int dod=0;
    for (int i=mmax-1;i>=0;i--)
    {
        a.num[i]=a.num[i]*b+dod;
        dod=0;
        if (a.num[i]>=10)
            dod+=a.num[i]/10,a.num[i]%=10;
    }
}

void divide(Tnode &a,const int &b)
{
    int help=0;
    for (int i=1;i<mmax;i++)
    {
        help=help*10+a.num[i];
        a.num[i]=help/b;
        help%=b;
    }
}

void print(Tnode &a)
{
    int h=0;
    while (!a.num[h])
        h++;
    for (int i=h;i<mmax;i++)
        printf("%d",a.num[i]);
    puts("");
}

void clever_solution(int n,int k)
{
    Tnode ans;
    memset(ans.num,0,sizeof(ans.num));
    ans.num[mmax-1]=1;
    int div=1;
    for (int i=n;i>max(n-k,k);i--)
    {
        multiply(ans,i);
        divide(ans,div++);
    }
    print(ans);
}

int main()
{
    freopen("camps.in","r",stdin); freopen("camps.out","w",stdout);
#ifdef Ahoma
    freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
#endif // Ahoma
    int n,k;
    scanf("%d %d\n",&n,&k);
    clever_solution(n-1,k);
    return 0;
}
