/* GCC */
#include <algorithm>
#include <assert.h>
#include <string.h>
#include <memory.h>
#include <assert.h>
#include <iostream>
#include <iomanip>
#include <cstring>
#include <fstream>
#include <istream>
#include <ostream>
#include <cassert>
#include <complex>
#include <cstdlib>
#include <climits>
#include <math.h>
#include <bitset>
#include <vector>
#include <string>
#include <cstdio>
#include <memory>
#include <time.h>
#include <cmath>
#include <ctime>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const bool db = false;

#define fs first
#define sd second
#define mp make_pair
#define pb push_back
#define ppb pop_back

#define inf 1000000007
#define nmax 100100
#define mmax 8500000
#define eps 1e-12

int Par[nmax],Rank[nmax];

int find_set(int v)
{
    if (v==Par[v])
        return v;
    else return Par[v]=find_set(Par[v]);
}

void union_set(int a,int b)
{
    a=find_set(a);
    b=find_set(b);
    if (a!=b)
    {
        if (Rank[a]<Rank[b])
            swap(a,b);
        Par[b]=a;
        if (Rank[a]==Rank[b])
            Rank[a]++;
    }
}

struct Tnode{
    int from,to,cost,id;
};

bool cmp(Tnode a,Tnode b)
{
    return a.cost<b.cost || a.cost==b.cost && a.id<b.id;
}

Tnode query[mmax];

int main()
{
    freopen("roads.in","r",stdin); freopen("roads.out","w",stdout);
#ifdef Ahoma
    freopen("input.txt","r",stdin); freopen("output.txt","w",stdout);
#endif // Ahoma
    int n,m;
    scanf("%d %d\n",&n,&m);
    for (int i=1;i<=m;i++)
        scanf("%d %d %d",&query[i].from,&query[i].to,&query[i].cost),query[i].id=i;
    sort(query+1,query+m+1,&cmp);
    vector<int> ans;
    int to,from;
    for (int i=1;i<=n;i++)
        Par[i]=i,Rank[i]=0;
    for (int i=1;i<=m;i++)
    {
        to=query[i].to,from=query[i].from;
        if (find_set(to)!=find_set(from))
            union_set(to,from),ans.push_back(query[i].id);
    }
    for (int i=0;i<ans.size();i++)
    {
        printf("%d",ans[i]);
        if (i==int(ans.size())-1)
            puts("");
        else printf(" ");
    }
    return 0;
}
