/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

long long cur, ost;
long long m = 1000000000;
int n, s, i, k;
vector <int> otv;

void dob(int a)
{
    int i;

    ost = 0;
    for(i = 0; i < otv.size(); i++)
    {
        cur = otv[i];
        cur = cur * a;
        otv[i] = (cur + ost) % m;
        ost = (cur + ost) / m;
    }

    if(ost > 0)
        otv.push_back(ost);
}

void cha(int a)
{
    int i;

    ost = 0;
    k = otv.size() - 1;
    for(i = k; i >= 0; i--)
    {
        cur = ost * m;
        cur = cur + otv[i];
        ost = cur % a;
        otv[i] = cur / a;

        if(otv[i] == 0 && i == k)
            otv.pop_back();
    }
}

int main()
{
    freopen("camps.in", "r", stdin);
    freopen("camps.out", "w", stdout);

    otv.push_back(1);
    scanf("%d %d", &s, &n);
    if(n >= s / 2)
    {
        for(i = n + 1; i < s; i++)
        {
            dob(i);
        }

        for(i = 2; i <= s - n - 1; i++)
        {
            cha(i);
        }
    }
    else
    {
        for(i = s - n; i < s; i++)
            dob(i);

        for(i = 2; i <= n; i++)
            cha(i);
    }

    k = otv.size() - 1;
    printf("%d", otv[k]);
    k--;
    for(i = k; i >= 0; i--)
        printf("%09d", otv[i]);

    return 0;
}

