/* GCC */
#define db 0
#define fls 1
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#include <vector>
#include <iomanip>
#include <ctime>

using namespace std;

#define pb push_back
#define mkp make_pair
#define fs first
#define sc second

typedef long long ll;
typedef unsigned long long ull;
typedef long double ldbl;
typedef double dbl;

const int nmax = 8500000 + 7;
const int inf  = 1000000000 + 7;
const dbl e = 1e-6;
const ull base = 100000000; //10^8

pair < int, pair < pair < int,int > , int > > ms[nmax];
int ans[5000],p[5000];
int n,m,tp=0,a,b,c;

int dsu_get(int v){
    return (v==p[v])?v:(p[v]=dsu_get(p[v]));
}

void dsu_unite (int a,int b){
    a=dsu_get(a);
    b=dsu_get(b);
    if (rand()%2)
        swap(a,b);
    if (a!=b)
        p[b]=a;
}

int main()
{
    ios_base::sync_with_stdio(0);
    srand(time(NULL));

    if (fls){
        freopen("roads.in","r",stdin);
        freopen("roads.out","w",stdout);
    }
    else{
        freopen("input.txt","r",stdin);
        freopen("output.txt","w",stdout);
    }
    for (int i=1; i<5000; ++i)
        p[i]=i;

    cin >> n >> m;
    for (int i=0; i<m; ++i){
        cin >> a >> b >> c;
        ms[i]=mkp(c,mkp(mkp(a,b),i));
    }
    sort(ms,ms+m);
    int num;
    for (int i=0; i<m; ++i){
        c=ms[i].fs;
        a=ms[i].sc.fs.fs;
        b=ms[i].sc.fs.sc;
        num=ms[i].sc.sc;
        if (dsu_get(a)!=dsu_get(b)){
            dsu_unite(a,b);
            ans[tp]=num;
            ++tp;
        }
    }
    for (int i=0; i<tp-1; ++i)
        cout << ans[i]+1 << ' ';
    cout << ans[tp-1]+1 << '\n';
    return 0;
}
