/* GCC */
#include <iostream>

using namespace std;

long getNumberOfPositionsRecursion(int totalPlaces, int startPos, int placeNumber);

int main()
{
    freopen("camps.in", "r", stdin);
    freopen("camps.out", "w", stdout);

    int roadLength = 0;
    int campsNumber = 0;
    cin >> roadLength >> campsNumber;

    int totalCampPlaces = roadLength - 1;

    cout << getNumberOfPositionsRecursion(totalCampPlaces, 0, campsNumber) << endl;

    return 0;
}

long getNumberOfPositionsRecursion(int totalPlaces, int startPos, int placeNumber){
    if(placeNumber == 0){
        return 0;
    }
    if(placeNumber == (totalPlaces - startPos)){
        return 1;
    }
    if(placeNumber == 1){
        return (totalPlaces - startPos);
    }

    int fNull = getNumberOfPositionsRecursion(totalPlaces, startPos + 1, placeNumber);
    int fOne = getNumberOfPositionsRecursion(totalPlaces, startPos + 1, placeNumber - 1);
    return fNull + fOne;
}
