/* GCC */
#include <iostream>
#include <cstdio>
#include <vector>

using namespace std;

int n, m, ans = 0;
vector < vector <int> > base;

bool isEqual(vector <int> a, vector <int> b)
{
    if(a.size()!=b.size())return 0;
    for (int i = 0; i < (int)a.size();++i)
        if (a[i]!=b[i])
            return 0;
    return 1;
}

bool isSimilar(vector <int> a, vector <int> b)
{
    for (int i = 0; i < (int)a.size(); ++i)
    {
        vector <int> c;
        for (int j = i; j < (int)a.size(); ++j)
            c.push_back(a[j]);
        for (int j = 0; j < i; ++j)
            c.push_back(a[j]);
        if (isEqual(b, c))
            return 1;
    }
    return 0;
}

bool ok(vector <int> a)
{
    for (int i = 0; i < (int)base.size(); ++i)
        if (isSimilar(base[i], a))
            return 0;
    return 1;
}

void f(vector <int> a)
{
    if ((int)a.size() == n)
    {
        if (ok(a))
        {
            ans++;
            base.push_back(a);
        }
    }
    else
    {
        for (int i = 1; i <= m; ++i)
        {
            a.push_back(i);
            f(a);
            a.pop_back();
        }
    }
}

int main()
{
    freopen("umbrella.in", "r", stdin);
    freopen("umbrella.out", "w", stdout);
    cin >> n >> m;
    vector <int> a;
    f(a);
    cout << ans << "\n";
    return 0;
}
