/* GCC */
#include<iostream>
#include<cstdio>
#include<algorithm>
#include<vector>
#include<utility>

const int INF=99999999;

using namespace std;

vector<vector<pair<int,pair<int,int> > > > gr;
vector<int> used;
vector<int> d;
vector<int> p;

int main()
{
    freopen("roads.in","r",stdin);
    freopen("roads.out","w",stdout);
    int n,m,c,a,b;
    cin >> n >> m;
    gr.resize(n);
    p.resize(n);
    d.resize(n,INF);
    used.resize(n);
    int s=0;
    int f=n-1;
    d[s]=0;
    for(int i=0;i<m;i++)
    {
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].push_back(make_pair(b,make_pair(c,i+1)));
        gr[b].push_back(make_pair(a,make_pair(c,i+1)));
    }
    for(int i=0;i<n;i++)
    {
        int v=-1;
        for(int j=0;j<n;j++)
        {
            if(used[j]==false && (v==-1 || d[j]<d[v]))
            {
                v=j;
            }
        }
        if(d[v]==INF)
        {
            break;
        }
        used[v]=true;
        for(size_t j=0;j<gr[v].size();j++)
        {
            int to=gr[v][j].first;
            int len=gr[v][j].second.first;
            if(d[v]+len<d[to])
            {
                d[to]=d[v]+len;
                p[to]=v;
            }
        }
    }
    vector<int> path;
    int ve=f;
    while(ve!=s)
    {
        path.push_back(ve);
        ve=p[ve];
    }
    path.push_back(s);
    reverse(path.begin(),path.end());
    for(int i=0;i<path.size();i++)
    {
        if(i!=0)
        {
            cout << " ";
        }
        cout << path[i]+1;
    }
    cout << endl;
    return 0;
}
