/* GCC */
#include <fstream>
#include <string>

using namespace std;

int n, s, p = 4999;
int counter[5000];

ifstream input;
ofstream output;

void inc(int pos = 4999, int b = 1)
{
    if(counter[pos] >= 1000000000 - b)
    {
        counter[pos] = b + counter[pos] - 1000000000;
        inc(pos - 1);
    } else
    {
        counter[pos] += b;
    }

    if(pos < p)
        p = pos;
}

void mul(int b)
{
    unsigned long tmp = counter[4999] * b;
    if(tmp < 1000000000)
        counter[4999] = tmp;
    else
    {
        long t = tmp % 1000000000;
        counter[4999] = t;
        inc(4998, (tmp - t) / 1000000000);
    }
}

int main()
{
    counter[p] = 1;

    input.open("camps.in");
    input >> s >> n;
    input.close();

    if(n != 1)
    {
        for(int i = s - n; i > 0; i--)
        {
            mul(i);
        }

        output.open("camps.out");
        while(p < 5000)
        {
            if(counter[p] > 0)
            {
                output << counter[p];
            } else
            {
                output << "000000000";
            }
            p++;
        }
        output.close();
    } else
    {
        output.open("camps.out");
        output << (s - 1);
        output.close();
    }

    return 0;
}
