/* GCC */
#include <iostream>
#include <fstream>
#include <algorithm>
using namespace std;

int a[9000000][4],color[4500],List[4500];

void recsort(int l,int r)
{
    int x=a[(l+r)/2][2];
    int k=l-1;
    int m=r+1;
    int t=l;
    while (t<m)
    {
        if (a[t][2]>x)
        {
            m--;
            swap(a[t][1],a[m][1]);
            swap(a[t][2],a[m][2]);
            swap(a[t][3],a[m][3]);
            swap(a[t][0],a[m][0]);
        }
        else
        {
            if (a[t][2]<x)
            {
                k++;
                swap(a[t][1],a[k][1]);
                swap(a[t][2],a[k][2]);
                swap(a[t][3],a[k][3]);
                swap(a[t][0],a[k][0]);
            }
            t++;
        }
    }
    if (k>l) recsort(l,k);
    if (m<r) recsort(m,r);
}

int main()
{
    ifstream fin("roads.in");
    ofstream fout("roads.out");

    int n,m;
    fin>>n>>m;

    for (int i=1;i<=m;i++)
    {
        fin>>a[i][0]>>a[i][1]>>a[i][2];
        a[i][3]=i;
    }

    for (int i=0;i<4500;i++)
        color[i]=i;

    recsort(1,m);

    int d=1;
    for (int i=1;i<n;i++)
    {
        while (color[a[d][0]]==color[a[d][1]])
            d++;
        List[i]=a[d][3];
        int c1=color[a[d][0]],c2=color[a[d][1]];
        for (int j=1;j<=n;j++)
            if (color[j]==max(c1,c2))
                color[j]=min(c1,c2);
    }

    for (int i=1;i<n-1;i++)
        fout<<List[i]<<" ";
    fout<<List[n-1]<<"\n";
}
