/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, i, a, b, c, m, j, cur, p;
priority_queue < pair <int, pair <int, int> > > q;
vector < vector < pair <int, pair <int, int> > > > v;
bool flag[4100];
vector <int> otv;

int main()
{
    freopen("roads.in", "r", stdin);
    freopen("roads.out", "w", stdout);

    scanf("%d %d", &n, &m);
    v.resize(n);
    for(i = 0; i < m; i++)
    {
        scanf("%d %d %d", &a, &b, &c);
        a--;
        b--;
        v[a].push_back(mp(b, mp(c, i + 1)));
        v[b].push_back(mp(a, mp(c, i + 1)));
    }

    q.push(mp(0, mp(0, 0)));
    while(!q.empty())
    {
        if(otv.size() == n)
            break;

        cur = q.top().Y.X;
        p = q.top().Y.Y;
        q.pop();

        if(flag[cur] == true)
            continue;

        flag[cur] = true;
        otv.push_back(p);

        for(i = 0; i < v[cur].size(); i++)
        {
            p = v[cur][i].X;
            if(flag[p] == true)
                continue;

            q.push(mp(-v[cur][i].Y.X, mp(v[cur][i].X, v[cur][i].Y.Y)));
        }
    }

    for(i = 1; i < n - 1; i++)
        printf("%d ", otv[i]);
    printf("%d\n", otv[i]);

    return 0;
}



