/* GCC */
#include <iostream>
#include <fstream>
#include <string>
#include <cmath>
#include <math.h>
#include <cstring>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

typedef long long ll;


/////////////////////////

ll factor(int n)
{
    ll res=1;
    for (int i=2; i<=n; i++)
    {
        res *= i;
    }
    return res;
}

ll factor_q(int n, int start)
{
    ll res = 1;
    for (int i=start; i<=n; i++)
    {
        res *= i;
    }
    return res;
}

inline ll pos(int n, int k)
{
    ll res = factor_q(k, n+1)/(factor(k-n));
    return res;
}

int main()
{
    ifstream fin;
    fin.open("umbrella.in");
    ofstream fout;
    fout.open("umbrella.out");

    int m, n;
    fin >> n >> m;
    if (n==1) fout << 1 << "\n";
    else if (n==1) fout << m << "\n";
    else if (n==2)
    {
        if (m>=2)
        {
            fout << pos(n,m)*3 << "\n";
        }
    }
    else if (n==3)
    {
        if (m>=n) fout << pos(n,m)*6 << "\n";
        else fout << 4 << "\n";
    }
    else if (n==4)
    {
        if (m>=n) fout << pos(n,m)*13 << "\n";
        else fout << 2*m+1 << "\n";
    }
    else if (n==5)
    {
        if (m>=n) fout << pos(n,m)*26 << "\n";
        else fout << 2*m+1 << "\n";
    }
    else if (n==6)
    {
        if (m>=n) fout << pos(n,m)*52 << "\n";
        else fout << 2*m+1 << "\n";
    }
    else if (n==7)
    {
        if (m>=n) fout << pos(n,m)*104 << "\n";
        else fout << 2*m+1 << "\n";
    }
    else if (n==8)
    {
        if (m>=n) fout << pos(n,m)*208 << "\n";
        else fout << 2*m+1 << "\n";
    }
    else if (n==9)
    {
        if (m>=n) fout << pos(n,m)*416 << "\n";
        else fout << 2*m+1 << "\n";
    }

    //if (m>n) fout << pos(n,m)*(n+factor(n)/n);
    //else fout << m + (factor(n)/(factor(n-m)*n));

    //fout << factor_q(s, n+1);
}

