/* GCC */
#define db 0
#define fls 1
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <map>
#include <vector>
#include <iomanip>

using namespace std;

#define pb push_back
#define mkp make_pair
#define fs first
#define sc second

typedef long long ll;
typedef unsigned long long ull;
typedef long double ldbl;
typedef double dbl;

const int nmax = 200000 + 7;
const int inf  = 1000000000 + 7;
const dbl e = 1e-6;
const ull base = 100000000; //10^8
int a,b,c,d,sza;
int ans[nmax];
ull res[45007];

int gcd (int a, int b){
    return b?gcd(b,a%b):a;
}

void mult(ull v){
    ull p=0;
    for (int i=0; i<sza; ++i){
        p=p+res[i]*v;
        res[i]=(p%base);
        p/=base;
    }
    if (p!=0){
        res[sza]=p;
        ++sza;
        p=0;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);


    if (fls){
        freopen("camps.in","r",stdin);
        freopen("camps.out","w",stdout);
    }
    else{
        freopen("input.txt","r",stdin);
        freopen("output.txt","w",stdout);
    }
    memset(res,0,sizeof(res));
    sza=1;
    res[0]=1;
    memset(ans,0,sizeof(ans));

    scanf("%d%d",&a,&b);
    --a;

    c=a-b;
    d=b;

    if (d>c) swap(d,c);

    for (int i=c+1; i<=a; ++i)
        ++ans[i];


    int v,gc;

    for (int i=2; i<=d; ++i){
        v=i;
        for (int j=a; j>1&&v>1; --j){
            while (ans[j]>0 && v>1 &&gcd(j,v)>1){
                gc=gcd(j,v);
                if (gc>1){
                    --ans[j];
                    ++ans[j/gc];
                    v/=gc;
                }
            }
        }
    }

    /*for (int i=2; i<=a; ++i)
        cout << i << '=' << ans[i] << '\n';*/

    for (int i=2; i<=a; ++i)
        if (ans[i]>0)
            while (ans[i]>0){
                mult(i);
                --ans[i];
            }


    printf("%lld",res[sza-1]);
    for (int i=sza-2; i>=0; --i)
        printf("%08lld",res[i]);

    return 0;
}
