{ Free Pascal }
const k=4096;
type road=record
cost:longword;
x,y:word;
n:longword;
end;
type tmas=array[1..4096] of boolean;
type myroad=array[1..8386560] of road;
type grafmas=array[1..4096,1..4096] of longword;

procedure dfs(i,m,n:word;var graf:grafmas;var used:tmas );
 var j:word;
begin
  for j:=1 to n do
    begin
      if (not used[j]) and (graf[i][j]>0) then
        begin
         used[j]:=true;
         dfs(j,m,n,graf,used);
        end;
    end;
end;
procedure sort(var rds:myroad;m:longword);
  var i,j,max:longword;
  temp:road;
begin
  for i:=1 to m-1 do
    begin
      max:=i;
      for j:=i+1 to m do
        if (rds[j].cost>rds[max].cost) then
          max:=j;
      temp:=rds[i];
      rds[i]:=rds[max];
      rds[max]:=temp;
    end;
end;

var
 f,t:textfile;
 n,m:longword;
    i,j:longword;
    allroads:myroad;
    graf:grafmas;
    used:tmas;
begin
  assign(f,'roads.in');
  assign(t,'roads.out');
  reset(f);
  rewrite(t);
  read(f,n,m);
  fillchar(graf,sizeof(graf),0);
  fillchar(used,sizeof(used),false);
  for i:=1 to m do
        begin
          read(f, allroads[i].x,allroads[i].y,allroads[i].cost);
          allroads[i].n:=i;
          graf[allroads[i].x][allroads[i].y]:=allroads[i].cost;
          graf[allroads[i].y][allroads[i].x]:=allroads[i].cost;
        end;
  sort(allroads,m);
  for i:=m downto m-n+2 do
    write(t,allroads[i].n,' ');
  writeln(t);
  close(f);
  close(t);
end.
